routes/web.php
<?php

use App\Http\Controllers\ImagesCommentsController;
use App\Http\Controllers\ImagesController;
use App\Http\Controllers\UsersController;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::middleware('language')->group(function() {

    Route::get('/', [ImagesController::class, 'index'])->name('home');
    Route::resource('images', ImagesController::class)->only(['index','show', 'create', 'store', 'destroy']);
    Route::resource('users', UsersController::class)->only(['show', 'edit', 'update']);
    Route::resource('images.comments', ImagesCommentsController::class)->only(['store'])
        ->middleware('auth');

    Auth::routes();

    });

    Route::get('language/{locale}', [\App\Http\Controllers\LanguageSwitcherController::class, 'switcher'])
        ->name('language.switcher')
        ->where('locale', 'en|ru');

app/Models/Image.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\BelongsTo;
use Illuminate\Database\Eloquent\Relations\HasMany;
use Orchid\Screen\AsSource;

class Image extends Model
{
    use HasFactory, AsSource;

    /**
     * @var string[]
     */
    protected $fillable = ['title', 'image', 'user_id'];

    /**
     * @return BelongsTo
     */
    public function user(): BelongsTo
    {
        return $this->belongsTo(User::class);
    }

    /**
     * @return HasMany
     */
    public function comments(): HasMany
    {
        return $this->hasMany(Comment::class)
            ->orderBy('id', "DESC");
    }
}

app/Http/Controllers/ImagesController.php
<?php

namespace App\Http\Controllers;

use App\Http\Requests\ImageRequest;
use App\Models\Image;
use Illuminate\Auth\Access\AuthorizationException;
use Illuminate\Contracts\Foundation\Application;
use Illuminate\Contracts\View\Factory;
use Illuminate\Contracts\View\View;
use Illuminate\Http\RedirectResponse;
use Illuminate\Http\Request;

class ImagesController extends Controller
{

    /**
     * @return Application|Factory|View
     */
    public function index()
    {
        $images = Image::orderBy('id', 'desc')
            ->paginate(9);

        return view('clients.images.index', compact('images'));
    }


    /**
     * @return Application|Factory|View
     * @throws AuthorizationException
     */
    public function create()
    {
        $this->authorize('create', Image::class);
        return  view('clients.images.create');
    }


    /**
     * @param ImageRequest $request
     * @return RedirectResponse
     */
    public function store(ImageRequest $request): RedirectResponse
    {
        $image = new Image();
        $image->title = $request->input('title');
        if ($request->hasFile('image')) {
            $file = $request->file('image');
            $path = $file->store('images', 'public');
            $image->image = $path;
        }
        $image->user()->associate($request->user());
        $image->save();

        return redirect()->route('users.show',$image->user_id);
    }


    /**
     * @param Image $image
     * @return Application|Factory|View
     */
    public function show(Image $image)
    {
        if($image->comments->count() !== 0) {
            foreach ($image->comments as $comment) {
                $ratings[] = $comment['rating'];
            }
            $rating  = collect($ratings)->avg();

        } else {
            $rating = 0;
        }

        return view('clients.images.show', compact('image', 'rating'));
    }


    /**
     * @param Image $image
     * @return RedirectResponse
     * @throws AuthorizationException
     */
    public function destroy(Image $image): RedirectResponse
    {
        $this->authorize('delete', $image);
        $image->delete();
        return redirect()->route('users.show',$image->user_id);
    }
}

resources/views/clients/images/create.blade.php
@extends('layouts.app')
@section('content')
    <div>
        <h3>@lang('messages.create_new_photo')</h3>
    </div>
    <form enctype="multipart/form-data" method="post" action="{{route('images.store')}}">
        @csrf
        <div class="form-group">
            <label for="title">@lang('messages.title')</label>
            <input type="text" class="form-control border-success  @error('title') is-invalid border-danger @enderror"
                   id="title" name="title">
        </div>
        @error('title')
        <p class="text-danger">{{ $message }}</p>
        @enderror
        <div class="form-group">
            <div class="custom-file">
                <label for="customFile">@lang('messages.choose_file')</label>
                <input type="file" class="custom-file-input @error('image') is-invalid border-danger @enderror"
                       id="customFile" name="image">
                <label class="custom-file-label" for="customFile">@lang('messages.choose_file')</label>
            </div>
        </div>
        @error('image')
        <p class="text-danger">{{ $message }}</p>
        @enderror
        <button type="submit" class="btn btn-outline-primary">@lang('messages.save')</button>
    </form>
@endsection

resources/views/clients/images/index.blade.php
@extends('layouts.app')
@section('content')

    <div class="row">
        @foreach($images as $image)
            <div class="col" style="padding: 35px 0 0 0;" >
                <div class="card" style="width: 18rem; height: 100%" >
                    <div style="height: 200px">
                        <a href="{{route('images.show', ['image' => $image])}}">
                            <img src="{{asset('/storage/' . $image->image)}}" class="card-img"
                                 alt="{{asset('/storage/' . $image->imag)}}" height="100%">
                        </a>
                    </div>
                    <div class="card-body d-flex flex-column">
                        <h5 class="card-title"><b>{{$image->title}}</b></h5>
                    </div>
                    <div class="card-footer">
                        <small>@lang('messages.author'): <a href="{{route('users.show', ['user' => $image->user])}}">{{$image->user->name}}</a></small>
                    </div>
                </div>
            </div>
        @endforeach
    </div>


    <div class="row justify-content-md-center p-5">
        <div class="col-md-auto">
            {{ $images->links('pagination::bootstrap-4') }}
        </div>
    </div>
@endsection

resources/views/clients/images/show.blade.php
@extends('layouts.app')
@section('content')

    <div>
        <h3><b>{{$image->title}}</b></h3>
        <div class="card" style="width: 18rem;">
            <img src="{{asset('/storage/' . $image->image)}}" class="card-img-one"
                 alt="{{asset('/storage/' . $image->imag)}}">
        </div>
    </div>


    <div>
        <p>@lang('messages.average_rating'): {{round($rating, 1)}}</p>
    </div>

    <div id="accordion">
        <div class="card">
            <div class="card-header" id="headingOne">
                <h5 class="mb-0">
                    <button class="btn btn-link collapsed" data-toggle="collapse" data-target="#collapseOne"
                            aria-expanded="true" aria-controls="collapseOne">@lang('messages.comments')
                    </button>
                </h5>
            </div>

            <div id="collapseOne" class="collapse" aria-labelledby="headingOne" data-parent="#accordion">
                <div class="card-body">
                    <div class="row">
                        <div class="col-8 scrollit">
                            @foreach($image->comments as $comment)
                                <div class="">
                                    <div class="media g-mb-30 media-comment">
                                        <div class="media-body u-shadow-v18 g-bg-secondary g-pa-30">
                                            <div class="g-mb-15">
                                                <h5 class="h5 g-color-gray-dark-v1 mb-0">{{$comment->user->name}}</h5>
                                                <span
                                                    class="g-color-gray-dark-v4 g-font-size-12">{{$comment->created_at->diffForHumans()}}</span>
                                            </div>
                                            <p>
                                                {{$comment->rating}}
                                            </p>
                                            <p>
                                                {{$comment->text}}
                                            </p>
                                        </div>
                                    </div>
                                </div>
                            @endforeach
                        </div>
                    </div>
                </div>
            </div>
        </div>
        @if(Auth::check())
            <div class="col-4 fixed">
                <div class="comment-form">
                    <form id="create-comment">
                        @csrf
                        <input type="hidden" id="image_id" value="{{$image->id}}">
                        <div class="form-group">
                            <label for="score">@lang('messages.rating')</label>
                            <select class="custom-select" name="rating" required>
                                <option value="">@lang('messages.choose_one')</option>
                                <option value="1">1</option>
                                <option value="2">2</option>
                                <option value="3">3</option>
                                <option value="4">4</option>
                                <option value="5">5</option>
                            </select>
                        </div>
                        <div class="form-group">
                            <label for="commentFormControl">@lang('messages.comment')</label>
                            <textarea name="text" class="form-control" id="commentFormControl" rows="3"
                                      required></textarea>
                        </div>
                        <button id="create-comment-btn" type="submit" class="btn btn-outline-primary btn-sm btn-block">
                            @lang('messages.add_new_comment')
                        </button>
                    </form>
                </div>
            </div>
    </div>
    @endif

@endsection